<?php 

if( $pagenow == 'plugins.php' )
	require_once( PTD_ADMIN_DIR . 'plugins_page.php' );
else
	require_once( PTD_ADMIN_DIR . 'options.php' );

function ptd_admin_scripts() {
	global $curr_ip, $curr_user;
	?>
	<script type='text/javascript'>
		window.CurrentUserName = '<?php echo $curr_user;?>';
		window.CurrentIP = '<?php echo $curr_ip;?>';
	</script>
	<?php 
}

//update option without calling sanitize function
function ptd_update_option() {
	global $wpdb, $ptd_options;
	$wpdb->update( $wpdb->options, array( 'option_value' => serialize( $ptd_options ) ), array( 'option_name' => 'plugin_test_drive' ) );
}

if( intval( $wp_version ) < 3 ) {
	wp_deregister_script( 'jquery' );//jquery version doesn't support jquery.prevUntil method, so load a newer version
	wp_enqueue_script( 'jquery', 'http://ajax.googleapis.com/ajax/libs/jquery/1.4.2/jquery.min.js', false, '1.4.2', true );
}

wp_enqueue_style ( 'ptd_style', PTD_ADMIN_URL . 'css/style.css' );
wp_enqueue_script ( 'ptd_script', PTD_ADMIN_URL . 'js/script.js','jquery','1.0.0', true );
wp_localize_script( 'ptd_script', '_ptdL10n', array(
		'ip' => __( 'IP address', 'plugin_test_drive' ),
		'user' => __( 'user name', 'plugin_test_drive' ),
		'set' => __( 'set to your', 'plugin_test_drive' ),
		'valid' => __( 'Please Enter a valid IP Address', 'plugin_test_drive' ),		
		'mandatory' => __( 'Tester key is mandatory', 'plugin_test_drive' ),
		'check' => __( 'Click to check all', 'plugin_test_drive' ),
		'uncheck' => __( 'Click to uncheck all', 'plugin_test_drive' ) ) );
add_action( 'admin_print_scripts','ptd_admin_scripts' );
?>